package ru.dbotthepony.mc.otm.android.feature

import net.minecraft.server.level.ServerPlayer
import net.neoforged.neoforge.event.entity.living.LivingIncomingDamageEvent
import ru.dbotthepony.mc.otm.android.AndroidFeature
import ru.dbotthepony.mc.otm.capability.MatteryPlayer
import ru.dbotthepony.mc.otm.config.AndroidConfig
import ru.dbotthepony.mc.otm.core.isFall
import ru.dbotthepony.mc.otm.registry.game.AndroidFeatures
import ru.dbotthepony.mc.otm.triggers.FallDampenersSaveTrigger

class FallDampenersFeature(capability: MatteryPlayer) : AndroidFeature(AndroidFeatures.FALL_DAMPENERS, capability) {
	override fun onHurt(event: LivingIncomingDamageEvent) {
		if (event.source.isFall) {
			val reduction = (AndroidConfig.FALL_DAMAGE_REDUCTION_PER_LEVEL_P * (level + 1)).toFloat().coerceIn(0f, 1f)
			val flat = (AndroidConfig.FALL_DAMAGE_REDUCTION_PER_LEVEL_F * (level + 1)).toFloat().coerceIn(0f, Float.MAX_VALUE)

			val old = event.amount
			event.amount = ((event.amount - flat) * (1f - reduction)).coerceAtLeast(0f)

			if (event.amount == 0f) {
				event.isCanceled = true
			}

			if (ply is ServerPlayer && ply.health > event.amount && ply.health <= old) {
				FallDampenersSaveTrigger.trigger(ply as ServerPlayer)
			}
		}
	}
}
